#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>
#include <conio.h>
#include <windows.h>
#include <math.h>

const int INITIAL_OFFSET = 4100;
const int SEARCH_WIDTH = 2500;
const int INITIAL_MAX = (SEARCH_WIDTH*16);//40000
const int MINIMAL_WAV_LENGTH = INITIAL_MAX + INITIAL_OFFSET;
//INITIAL_MAX + INITIAL_OFFSET = 44100 = 1.0sec, at least 1.0 sec of sound is needed
const int WAV_MAX = (1+9);
const int PATH_LENGTH_MAX = 4000;

struct wav_common{
 double *initials;
 double gain;
 double score;//smaller the better
 int offset;
 int file_offset;
 int is_float;
 char thumbnail[16];
};

int init_wav_common(struct wav_common *wc){
 wc->gain = 1.0;
 wc->score = 0.0;
 wc->offset = 0;
 wc->file_offset = 0;
 wc->initials = (double *)malloc(sizeof(double)*INITIAL_MAX);
 if(wc->initials == NULL)exit(0);
 wc->is_float = 0;
 strcpy(wc->thumbnail,"??? ?>********>");
 return 0;
}

 /*------------------------------------------------------------------*/
 /*             Brute-force search of offset and gain                */
 /*              compare Wav-Original(wo) and Wav-Compare(wc)        */
 /*               results are stored in Wav-Compare(wc)              */
 /*------------------------------------------------------------------*/

int wav_gainoffset_search(struct wav_common *wo,struct wav_common *wc){
 int i,j,k;
 int offset;
 double bestscore = HUGE_VAL;
 double score;
 double bestamp = 0.0;
 int bestoffset = 0;
 double rmsampo = 0.0;  //  Root Mean Square AMPlitude of Original 
 for(i=SEARCH_WIDTH;i<SEARCH_WIDTH*13;i++){
  rmsampo += (wo->initials[i])*(wo->initials[i]);
 }
 for(offset=-SEARCH_WIDTH;offset<SEARCH_WIDTH*3;offset++){
  double rmsampc = 0.0;
  for(i=SEARCH_WIDTH;i<SEARCH_WIDTH*13;i++){
   rmsampc += (wc->initials[offset+i])*(wc->initials[offset+i]);
  }
  if(rmsampc==0.0){
   printf("No Sound At All.\r\n");
   return 0;
  }
  double theamp = sqrt(rmsampo/rmsampc);
  score = 0.0;
  for(i=SEARCH_WIDTH;i<SEARCH_WIDTH*13;i++){
   double error_wav = (wc->initials[offset+i]*theamp)-wo->initials[i];
   score += error_wav*error_wav;
   if(score>bestscore)break;
  }
  if(score<bestscore){
   bestscore = score;
   bestamp = theamp;
   bestoffset = offset;
  }
 }
 wc->gain = bestamp;
 wc->offset = bestoffset;
 wc->score = sqrt(bestscore/rmsampo);
 return 0;
}


 /*------------------------------------------------------------------*/
 /*             Main routine                                         */
 /*------------------------------------------------------------------*/


main(int argc, char **argv){
 char wav_path[WAV_MAX][PATH_LENGTH_MAX];
 int i,j,k,l;
 int input_wav_length = 0x7FFFFFFF;
 int input_sampling_rate;
 int intbuf;
 float flobuf;

 int wav_num;

 short sbuf;
 FILE WAV[WAV_MAX];
 FILE *wav[WAV_MAX];
 struct wav_common WAVC[WAV_MAX];
 struct wav_common *wavc[WAV_MAX];
 for(i=0;i<WAV_MAX;i++){
  wav[i] = &WAV[i];
  wavc[i] = &WAVC[i];
  init_wav_common(wavc[i]);
 }

 if(argc<3){
  int sw = SEARCH_WIDTH;
  printf("Abc/hr raw generator ver.1.1.1 (http://d.hatena.ne.jp/kamedo2/)\r\n");
  printf(" Equalize offset and gain of 32bit float or int 44100Hz wav files.\r\n");
  printf("  Then output them as raw, to perform an abc/hr test.\r\n\r\n");
  printf("    usage:  rawgene original.wav lossy1.wav lossy2.wav.....\r\n\r\n");
  printf("Detectable offset: %d ~ %d[sample].\r\n\r\n",-sw,sw*3-1);
  printf(" Yulewalk filter for 44.1kHz is used to normalize gain.\r\n");
  return 0;
 }

 printf("rawgene v.1.1.1  /  original reference file:%s\r\n",argv[1]);
 wav_num = argc-1;
 if(wav_num>WAV_MAX){
  printf("Too many lossy files : wav_num:%d.\r\n",wav_num);
  return 1;
 }
 for(i=0;i<wav_num;i++){
  char chunkstr[8] = {0};
  char t_nail[16] = {0};
  int chunk_length;
  int chunk_max = 10;
 /*------------------------------------------------------------------*/
 /*     Wav Files Validity Check(Must be 32bit uncompressed stereo)  */
 /*------------------------------------------------------------------*/
  strcpy(wav_path[i],argv[1+i]);
  wav[i] = fopen(wav_path[i],"rb");
  if(wav[i]==NULL){
   printf("Cannot open this file : %s.\r\n",wav_path[i]);
   return 2;
  }

  sprintf(t_nail,"??? %01d>",i);
  char *p;
  p = strrchr(wav_path[i],'\\');
  if(p!=NULL){
   p++;
  }
  else{
   p = wav_path[i];
  }
  strncat(t_nail,p,8);
  while(strlen(t_nail)<14)strcat(t_nail," ");
  strcat(t_nail,">");
  fread(chunkstr,1,4,wav[i]);
  if(strcmp(chunkstr,"RIFF")!=0){
   printf("RIFF != %s\r\n",chunkstr);
   printf("%s Not a valid RIFF WAV File: %s\r\n",t_nail,wav_path[i]);
   return 3;
  }
  fread(chunkstr,1,4,wav[i]);
  fread(chunkstr,1,4,wav[i]);
  if(strcmp(chunkstr,"WAVE")!=0)printf("WAVE != %s\r\n",chunkstr);
  fread(chunkstr,1,4,wav[i]);
  while(strcmp(chunkstr,"fmt ")!=0 && (chunk_max>0)){
   printf("%s skipped unknown chunk '%s' while searching 'fmt '.\r\n",t_nail,chunkstr);
   fread(&chunk_length,4,1,wav[i]);
   for(j=0;j<chunk_length;j++)fread(chunkstr,1,1,wav[i]);
   fread(chunkstr,1,4,wav[i]);
   chunk_max--;
  }
  if(chunk_max==0){
   printf("%s Chunks too much.\r\n",t_nail);
   return 3;
  }
  fread(&chunk_length,4,1,wav[i]);
  fread(chunkstr,1,4,wav[i]);
  int wav_type = (chunkstr[1]<<8)|chunkstr[0];
  if(wav_type==3){
   wavc[i]->is_float = 1;  //Microsoft float 32bit wav file
   t_nail[0] = 'F';
   t_nail[1] = 'L';
   t_nail[2] = 'O';
  }
  else if(wav_type==1 || wav_type==-2){
   wavc[i]->is_float = 0;  //Normal wav file
                           //WAVE_FORMAT_EXTENSIBLE
   t_nail[0] = 'I';
   t_nail[1] = 'N';
   t_nail[2] = 'T';
  }
  else{
   printf("%s This is not a linear(integer) or float PCM. %d\r\n",t_nail,wav_type);
   return 4;//not linear or float PCM
  }
  strcpy(wavc[i]->thumbnail,t_nail);
  if(chunkstr[3]!=0 || chunkstr[2]!=2){
   printf("%s This is not a stereo file.\r\n",t_nail);
   return 5;//channel number error.
  }
  fread(&input_sampling_rate,1,4,wav[i]);
  if(input_sampling_rate!=44100){
   printf("%s Using sample rate other than 44.1kHz is not recommended.\r\n",t_nail);
  }
  fread(&intbuf,1,4,wav[i]);
  if(intbuf!=input_sampling_rate*8){
   printf("%s This is not a 32bit depth wave file.\r\n",t_nail);
   return 6;//16bit,24bit...etc
  }
  for(j=0;j<chunk_length-12;j++)fread(chunkstr,1,1,wav[i]);
  //printf("%d fmt complete\r\n",i);
  fread(chunkstr,1,4,wav[i]);
  while(strcmp(chunkstr,"data")!=0 && (chunk_max>0)){
   //printf("%s skipped unknown chunk '%s' while searching 'data'.\r\n",t_nail,chunkstr);
   fread(&chunk_length,4,1,wav[i]);
   for(j=0;j<chunk_length;j++)fread(chunkstr,1,1,wav[i]);
   fread(chunkstr,1,4,wav[i]);
   chunk_max--;
  }
  if(chunk_max==0){
   printf("%s There are no data chunk.\r\n",t_nail);
   return 7;
  }
  fread(&intbuf,4,1,wav[i]);
  if(intbuf&0x07)printf("%s ILLEGAL DATA CHUNK LENGTH : %d\r\n",t_nail,intbuf);
  intbuf /= 8;
  if(intbuf<input_wav_length){
   input_wav_length = intbuf;
   if(input_wav_length<MINIMAL_WAV_LENGTH){
    printf("MINIMAL_WAV_LENGTH : %d[samples]\r\n",MINIMAL_WAV_LENGTH);
    printf("input_wav_length : %d[samples]\r\n",input_wav_length);
    printf("%s INPUT FILES TOO SHORT.\r\n",t_nail);
    return 8;
   }
  }
 }
 printf("\r\n");
 /*------------------------------------------------------------------*/
 /*     Cut inaudible sounds by Yulewalk filter,                     */
 /*      and store INITIAL_OFFSET~MINIMAL_WAV_LENGTH section         */
 /*       of the sound for further analysis                          */
 /*------------------------------------------------------------------*/

 //"Yulewalk" filter
 double iir_l_left[10];
 double iir_l_right[10];
 double iir_b_left[10];
 double iir_b_right[10];

 for(i=0;i<wav_num;i++){
  wavc[i]->file_offset = (int)ftell(wav[i]);
  double dbuf;
  double cap1,cap0;
  for(k=0;k<10;k++){
   iir_l_left[k] = iir_l_right[k] = 0;
   iir_b_left[k] = iir_b_right[k] = 0;
  }
  for(j=0;j<MINIMAL_WAV_LENGTH;j++){
   if(wavc[i]->is_float){
    fread(&flobuf,4,1,wav[i]);
    dbuf = (double)flobuf;
    fread(&flobuf,4,1,wav[i]);
    dbuf += (double)flobuf;
   }
   else{
    fread(&intbuf,4,1,wav[i]);
    dbuf = (double)intbuf;
    fread(&intbuf,4,1,wav[i]);
    dbuf += (double)intbuf;
    dbuf /= 2147483648.0;//32bit 2^31
   }

   //dbuf = ((rand()&1)-0.5)*10000000000.0;

   cap0 = dbuf*0.98500175787242;
   cap0 -= iir_b_left[0]*1.97000351574484;
   cap0 += iir_b_left[1]*0.98500175787242;
   iir_b_left[1] = iir_b_left[0];
   iir_b_left[0] = dbuf;
   cap0 += iir_b_right[0]*1.96977855582618;
   cap0 -= iir_b_right[1]*0.97022847566350;
   iir_b_right[1] = iir_b_right[0];
   iir_b_right[0] = cap0;

   cap1 = cap0*0.05418656406430;

   cap1 -= iir_l_left[0]*0.02911007808948;
   cap1 -= iir_l_left[1]*0.00848709379851;
   cap1 -= iir_l_left[2]*0.00851165645469;
   cap1 -= iir_l_left[3]*0.00834990904936;
   cap1 += iir_l_left[4]*0.02245293253339;
   cap1 -= iir_l_left[5]*0.02596338512915;
   cap1 += iir_l_left[6]*0.01624864962975;
   cap1 -= iir_l_left[7]*0.00240879051584;
   cap1 += iir_l_left[8]*0.00674613682247;
   cap1 -= iir_l_left[9]*0.00187763777362;
   iir_l_left[9] = iir_l_left[8];
   iir_l_left[8] = iir_l_left[7];
   iir_l_left[7] = iir_l_left[6];
   iir_l_left[6] = iir_l_left[5];
   iir_l_left[5] = iir_l_left[4];
   iir_l_left[4] = iir_l_left[3];
   iir_l_left[3] = iir_l_left[2];
   iir_l_left[2] = iir_l_left[1];
   iir_l_left[1] = iir_l_left[0];
   iir_l_left[0] = cap0;
   cap1 += iir_l_right[0]*3.47845948550071;
   cap1 -= iir_l_right[1]*6.36317777566148;
   cap1 += iir_l_right[2]*8.54751527471874;
   cap1 -= iir_l_right[3]*9.47693607801280;
   cap1 += iir_l_right[4]*8.81498681370155;
   cap1 -= iir_l_right[5]*6.85401540936998;
   cap1 += iir_l_right[6]*4.39470996079559;
   cap1 -= iir_l_right[7]*2.19611684890774;
   cap1 += iir_l_right[8]*0.75104302451432;
   cap1 -= iir_l_right[9]*0.13149317958808;
   iir_l_right[9] = iir_l_right[8];
   iir_l_right[8] = iir_l_right[7];
   iir_l_right[7] = iir_l_right[6];
   iir_l_right[6] = iir_l_right[5];
   iir_l_right[5] = iir_l_right[4];
   iir_l_right[4] = iir_l_right[3];
   iir_l_right[3] = iir_l_right[2];
   iir_l_right[2] = iir_l_right[1];
   iir_l_right[1] = iir_l_right[0];
   iir_l_right[0] = cap1;

   if(j>=INITIAL_OFFSET){
    wavc[i]->initials[j-INITIAL_OFFSET] = cap1;
   }
  }
 }
 int biggest_delay = 0;
 int smallest_delay = 0;
 double biggest_gain = 1.0;
 /*------------------------------------------------------------------*/
 /*     Execute wav_gainoffset_search(Brute-force offset search)     */
 /*------------------------------------------------------------------*/
 for(i=1;i<wav_num;i++){
  wav_gainoffset_search(wavc[0],wavc[i]);
  if(wavc[i]->offset<smallest_delay)smallest_delay = wavc[i]->offset;
  if(biggest_delay<wavc[i]->offset)biggest_delay = wavc[i]->offset;
  if(biggest_gain<wavc[i]->gain)biggest_gain = wavc[i]->gain;
  printf("%s ",wavc[i]->thumbnail);
  printf("Offset:%5d   ",wavc[i]->offset);
  printf("Gain:%f , ",wavc[i]->gain);
  printf("%f[dB]   ",20.0*log10(wavc[i]->gain));
  printf("Score:%f\r\n",wavc[i]->score);
 }
 input_wav_length -= (biggest_delay-smallest_delay);
 printf("biggest_delay    : %d\r\n",biggest_delay);
 printf("smallest_delay   : %d\r\n",smallest_delay);
 printf("biggest_gain     : %f\r\n",biggest_gain);
 printf("input_wav_length : %d\r\n",input_wav_length);
 /*------------------------------------------------------------------*/
 /*     Output gain&offset adjusted sounds as raw                    */
 /*------------------------------------------------------------------*/
 for(i=0;i<wav_num;i++){
  fseek(wav[i],wavc[i]->file_offset+(wavc[i]->offset-smallest_delay)*8,SEEK_SET);
  FILE *rawout;
  char *sp = strstr(wav_path[i],".32b.wav");
  if(sp!=NULL)sp[0] = '\0';
  strcat(wav_path[i],".raw");
  rawout = fopen(wav_path[i],"wb");
  if(rawout==NULL){
   printf("Output path is not available.\r\n");
   return 9;
  }
  double thegain = wavc[i]->gain*32768.0/(biggest_gain*1.2);
  int clipped = 0;
  for(j=0;j<input_wav_length*2;j++){
   if(wavc[i]->is_float){
    fread(&flobuf,4,1,wav[i]);
   }
   else{
    fread(&intbuf,4,1,wav[i]);
    flobuf = intbuf/2147483648.0;//32bit 2^31
   }
   int ibtg = (int)(100000.0+flobuf*thegain)-100000;
   if(ibtg<-32700 || 32700<ibtg){
    clipped++;
    if(ibtg<-32700)ibtg = -32700;
    if(ibtg>32700)ibtg = 32700;
   }
   char cbuf;
   cbuf = ibtg&0xFF;
   fwrite(&cbuf,1,1,rawout);
   cbuf = ibtg>>8;
   fwrite(&cbuf,1,1,rawout);
  }
  //printf("i:%d  ",i);
  if(clipped){
   printf("%s Clipped %d times.\r\n",wavc[i]->thumbnail,clipped);
  }
  //printf("\r\n");
  free(wavc[i]->initials);
  wavc[i]->initials = NULL;
  fclose(wav[i]);
 }


 /*
 FILE *output_wav;
 output_wav = fopen("test_originial.wav","wb");
 if(output_wav==NULL){
  printf("Output path is not available.\r\n");
  return 10;
 }
 fputs("RIFF",output_wav);
 intbuf = 44-8+INITIAL_MAX*8;
 fwrite(&intbuf,4,1,output_wav);
 fputs("WAVE",output_wav);
 fputs("fmt ",output_wav);
 intbuf = 16;
 fwrite(&intbuf,4,1,output_wav);
 intbuf = 65536*2+1;
 fwrite(&intbuf,4,1,output_wav);
 intbuf = input_sampling_rate;
 fwrite(&intbuf,4,1,output_wav);
 intbuf *= 2*4;
 fwrite(&intbuf,4,1,output_wav);
 intbuf = 65536*32+2*4;
 fwrite(&intbuf,4,1,output_wav);
 fputs("data",output_wav);
 intbuf = INITIAL_MAX*8;
 fwrite(&intbuf,4,1,output_wav);

 for(i=0;i<INITIAL_MAX;i++){
  for(j=0;j<2;j++){
   int s = wavc[0]->initials[i];
   fwrite(&s,4,1,output_wav);
  }
 }
 fclose(output_wav);
 */
 Sleep(1000); 
 return 0;
}

